%M: number of sensors, N: number of sources
%currently only suare case works
M=3;
N=3;
%number of experiments
num_exp=100;
%load pregenerated 3x3 mixing matrices
load H.mat

%shape parameters to test
c_vec=[0.25:0.05:1 1.125 1.25 1.5:0.5:8];
%differences in noncircularity indices to test
delta_gam_vec=[0:0.05:0.45];

%preallocate arrays
sol_MLICA=zeros(M,M,num_exp,length(delta_gam_vec),length(c_vec));
sol_MLICA_initEBM=zeros(M,M,num_exp,length(delta_gam_vec),length(c_vec));
sol_ICA_EBM=zeros(M,M,num_exp,length(delta_gam_vec),length(c_vec));

%number of samples
frameNum=1000;
p_c=1;
p_gam=1;
for c=c_vec
    if c<0.5
        maxIterICA=5000;
    else
	  %in some cases necessary but can be reduced if smaller accuracy is sufficient
        maxIterICA=50000;
    end
    p_c
    p_gam=1;
    for delta_gam=delta_gam_vec
        p_gam
        S_exp=zeros(M, frameNum,num_exp);
        
	  %all sources have same shape parameter c but different noncircularity indices
        c_v=ones(1,N)*c;
        gam_v=[0 delta_gam 2*delta_gam];
        for p_num_exp=1:num_exp
            S_exp(:,:,p_num_exp)=getComplexGGD_mat_diff(M,frameNum, c_v, gam_v);
        end
        
                
        J_ICA_iter=zeros(maxIterICA,1);
        W_iter=zeros(M,M,maxIterICA);
        for p_num_exp=1:num_exp
            
            H=H_(:,:,p_num_exp);
            S=S_exp(:,:,p_num_exp);
            S=diag(1./std(S.'))*S;
            
            X=H*S;
            
            tic
                       
            W=complex_ICA_EBM(X);
            W=solve_permut(W,H,X);
            sol_ICA_EBM(:,:,p_num_exp,p_gam,p_c)=W;
            
            [W,W_iter,iter, J_ICA_iter]=MLICA_scaledNG(W, X, c_v, gam_v, maxIterICA);
            W=solve_permut(W,H,X);
            sol_MLICA_initEBM(:,:,p_num_exp,p_gam,p_c)=W;
	    
	    W_init=eye(M);
    	    [W,W_iter,iter, J_ICA_iter]=MLICA_scaledNG(W_init, X, c_v, gam_v, maxIterICA);
            W=solve_permut(W,H,X);
            sol_MLICA(:,:,p_num_exp,p_gam,p_c)=W;        
            toc
        end
        p_gam=p_gam+1;
        save(['./results/results_complex_L' num2str(frameNum) '_N3_diffgam.mat'], 'frameNum', 'sol_MLICA', 'sol_MLICA_initEBM', 'sol_ICA_EBM', 'c_vec', 'delta_gam_vec', 'H_', 'num_exp');
    end
    p_c=p_c+1;
end
