%script to plot figures 2 and 3
%gamstr='samegam' (figure 2) or 'diffgam' (figure 3)
%same noncircularity for all sources or different noncircularity

clear all;
gamstr='samegam';
p_L=1;
for L=1000
    load(['results_complex_L' num2str(L) '_N3_' gamstr '.mat']);
    if strcmp(gamstr, 'diffgam')
        
    else
        delta_gam_vec=gam_vec;
    end
    G_MLICA=zeros(3,3,num_exp,length(c_vec),length(delta_gam_vec));
    G_ICA_EBM=zeros(3,3,num_exp,length(c_vec),length(delta_gam_vec));
    SIR_MLICA=zeros(length(c_vec),length(delta_gam_vec));
    SIR_ICA_EBM=zeros(length(c_vec),length(delta_gam_vec));
        
    
    
    for p=1:length(c_vec)
        for p2=1:length(delta_gam_vec)
            for p3=1:num_exp
                
                
                G_MLICA(:,:,p3,p,p2)=sol_MLICA_initEBM(:,:,p3,p2,p)*H_(:,:,p3);
                G_ICA_EBM(:,:,p3,p,p2)=sol_ICA_EBM(:,:,p3,p2,p)*H_(:,:,p3);
                
                
            end
            SIR_MLICA(p,p2)=mean(est_SIR(G_MLICA(:,:,:,p,p2)));
            SIR_ICA_EBM(p,p2)=mean(est_SIR(G_ICA_EBM(:,:,:,p,p2)));
            
        end
    end
    c_vec_CRB=[0.25:0.025:1.1 1.2:0.05:8];
    G2_CRB=zeros(3,3,length(c_vec_CRB),length(delta_gam_vec));
    CRB_=zeros(3,3,length(c_vec_CRB),length(delta_gam_vec));
    SIR_CRB=zeros(length(c_vec_CRB),length(delta_gam_vec));
    
    for p=1:length(c_vec_CRB)
        for p2=1:length(delta_gam_vec)
            for k=1:3
                c=c_vec_CRB(p);
                if strcmp(gamstr, 'diffgam')
                    gam(k)=(k-1)*delta_gam_vec(p2);
                else
                    gam(k)=gam_vec(p2);
                end
                kappa(k)=c^2*gamma(2./c)./((1-gam(k)^2)*(gamma(1/c))^2);
                xi(k)=-c^2*gam(k)*gamma(2./c)./((1-gam(k)^2)*(gamma(1/c))^2); %-gam*kappa;
                eta(k)=-(c+1)*(gam(k)^2-2)/(2*(1-gam(k)^2));
                beta(k)=-(c+1)*(3*gam(k)^2-2)/(2*(1-gam(k)^2));
                
            end
            
            for i=1:3
                for j=1:3
                    if i~=j
                        CRB(i,j)=(kappa(j)*(kappa(i)*kappa(j)-1)-abs(gam(i)*xi(j))^2*kappa(i))/max(((kappa(i)*kappa(j)-1)^2+abs(gam(i)*gam(j)*xi(i)*xi(j)-1)^2-1-kappa(i)^2*abs(gam(i)*xi(j))^2-kappa(j)^2*abs(gam(j)*xi(i))^2),0);
                    else
                        if abs(eta(i)-beta(i))>1e-16
                            CRB(i,i)=(eta(i)-1)/((eta(i)-1)^2-abs(beta(i)-1)^2);
                        else
                            CRB(i,i)=1/(4*(eta(i)-1));
                        end
                    end
                end
            end
            
            CRB_(:,:,p,p2)=CRB;
            G2_CRB(:,:,p,p2)=eye(3)+1/L*(CRB);
            
            SIR_CRB(p,p2)= mean(diag(G2_CRB(:,:,p,p2))./sum(G2_CRB(:,:,p,p2)-diag(diag(G2_CRB(:,:,p,p2))),2));
            
        end
    end
    %to avoid missing contour lines
    SIR_CRB(isnan(SIR_CRB))=2;
    
    make_ICA_CRB_plot_new(delta_gam_vec, c_vec_CRB, SIR_CRB,gamstr);
    print('-depsc', ['ICA_CRB_L' num2str(L) '_N3_' gamstr '.eps']);
    
    make_ICA_CRB_plot_new(delta_gam_vec, c_vec, SIR_MLICA,gamstr);
    print('-depsc', ['ICA_CRB_MLICA_L' num2str(L) '_N3_' gamstr '.eps']);
    
    make_ICA_CRB_plot_new(delta_gam_vec, c_vec, SIR_ICA_EBM,gamstr);
    print('-depsc', ['ICA_CRB_ICA_EBM_L' num2str(L) '_N3_' gamstr '.eps']);
    
end