%script to plot figures 6 and 7
%i.e. performance as a function of sample size

clear all;
p_L=1;
gamstr='diffgam';
L_vec=[10 20 50 100 200 500 1000 2000 5000 10000];
%load first dataset to get required parrams
load(['results_complex_L' num2str(L_vec(1)) '_N3_' gamstr '.mat']);

G_MLICA=zeros(3,3,100,length(c_vec),length(delta_gam_vec),length(L_vec));
G_ICA_EBM=zeros(3,3,100,length(c_vec),length(delta_gam_vec),length(L_vec));
G2_CRB=zeros(3,3,100,length(c_vec),length(delta_gam_vec),length(L_vec));
CRB_=zeros(3,3,100,length(c_vec),length(delta_gam_vec),length(L_vec));

SIR_MLICA=zeros(length(c_vec),length(delta_gam_vec),length(L_vec));
SIR_ICA_EBM=zeros(length(c_vec),length(delta_gam_vec),length(L_vec));
SIR_CRB=zeros(length(c_vec),length(delta_gam_vec),length(L_vec));


for L=L_vec
    load(['results_complex_L' num2str(L) '_N3_' gamstr '.mat']);
    
    
    for p=1:length(c_vec)
        for p2=1:length(delta_gam_vec)
            for p3=1:num_exp
                
                
                G_MLICA(:,:,p3,p,p2,p_L)=sol_MLICA_initEBM(:,:,p3,p2,p)*H_(:,:,p3);
                G_ICA_EBM(:,:,p3,p,p2,p_L)=sol_ICA_EBM(:,:,p3,p2,p)*H_(:,:,p3);
            end
            SIR_MLICA(p,p2,p_L)=mean(est_SIR(G_MLICA(:,:,:,p,p2,p_L)));
            SIR_ICA_EBM(p,p2,p_L)=mean(est_SIR(G_ICA_EBM(:,:,:,p,p2,p_L)));
        end
    end
    for p=1:length(c_vec)
        for p2=1:length(delta_gam_vec)
            for k=1:3
                c=c_vec(p);
                if strcmp(gamstr, 'diffgam')
                    gam(k)=(k-1)*delta_gam_vec(p2);
                else
                    gam(k)=gam_vec(p2);
                end
                kappa(k)=c^2*gamma(2./c)./((1-gam(k)^2)*(gamma(1/c))^2);
                xi(k)=-c^2*gam(k)*gamma(2./c)./((1-gam(k)^2)*(gamma(1/c))^2); %-gam*kappa;
                eta(k)=-(c+1)*(gam(k)^2-2)/(2*(1-gam(k)^2));
                beta(k)=-(c+1)*(3*gam(k)^2-2)/(2*(1-gam(k)^2));
                
            end
            for i=1:3
                for j=1:3
                    if i~=j
                        CRB(i,j)=(kappa(j)*(kappa(i)*kappa(j)-1)-abs(gam(i)*xi(j))^2*kappa(i))/((kappa(i)*kappa(j)-1)^2+abs(gam(i)*gam(j)*xi(i)*xi(j)-1)^2-1-kappa(i)^2*abs(gam(i)*xi(j))^2-kappa(j)^2*abs(gam(j)*xi(i))^2);
                    else
                        CRB(i,i)=(eta(i)-1)/((eta(i)-1)^2-abs(beta(i)-1)^2);
                    end
                end
            end
            
            CRB(isinf(CRB))=0;
            CRB_(:,:,p,p2)=CRB;
            G2_CRB(:,:,p,p2,p_L)=eye(3)+1/L*(CRB);
            %only occurs if more than one source is circular Gaussian
            G2_CRB(isnan(G2_CRB))=inf;
            SIR_CRB(p,p2,p_L)= mean(diag(G2_CRB(:,:,p,p2,p_L))./sum(G2_CRB(:,:,p,p2,p_L)-diag(diag(G2_CRB(:,:,p,p2,p_L))),2));
            
        end
    end
    p_L=p_L+1
    
    
    
end

%here c is an index into c_vec, i.e. c_vec(16)==1
%likewise gam is an index into deltagam_vec
c=16; gam=10; make_ICA_CRB_plot_samplesize_new2
print -depsc ICA_CRB_samplesize_c1_deltagam_0.45_new2.eps
c=6; gam=1; make_ICA_CRB_plot_samplesize_new2
print -depsc ICA_CRB_samplesize_c0.5_deltagam_0_new2.eps
c=28; gam=1; make_ICA_CRB_plot_samplesize_new2
print -depsc ICA_CRB_samplesize_c6_deltagam_0_new2.eps
c=6; gam=10; make_ICA_CRB_plot_samplesize_new2
print -depsc ICA_CRB_samplesize_c0.5_deltagam_0.45_new2.eps
c=28; gam=10; make_ICA_CRB_plot_samplesize_new2
print -depsc ICA_CRB_samplesize_c6_deltagam_0.45_new2.eps
c=18; gam=10; make_ICA_CRB_plot_samplesize_new2
print -depsc ICA_CRB_samplesize_c2_deltagam_0.45_new2.eps




